#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <sprite.h>
#include <mfsprite.h>
#include "xhtile.h"
#include "xhwin.h"
#include "sonic.h"
#include "zoneobj.h"
#include "ring.h"
#include "monitor.h"
#include "enemy.h"
#include "buzzbot.h"
#include "spring.h"

#include "type1.xpm"
#include "type2.xpm"
#include "type3.xpm"
#include "type4.xpm"
#include "type5.xpm"
#include "type6.xpm"
#include "type7.xpm"
#include "type8.xpm"
#include "type9.xpm"
#include "type10.xpm"
#include "type11.xpm"
#include "type12.xpm"
#include "type13.xpm"
#include "type14.xpm"

#define NUMTILES 17
// Key:
// A = checkers
// B = ground --
// C = ground shadow
// D = flower stem
// E = flower top
// F = ground \ high
// G = ground \ low
// H = ground / high
// I = ground / low
// J = ground \ shadow
// K = ground \ shadow
// L = ground / shadow
// M = ground / shadow
// N = checkers (impenetrable)
// O = ground -- (impenetrable)
// P = ground shadow (impenetrable)

char DllZoneTitle[] = "Test Bay";

char *tile_data[] = {
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                                                                                                                     ",
"                              	       	                                                                              ",
"                                                                                                                     ",
"                                                                                                                     ",
"      	       	                              E                                                                       ",
"                                             D                                                                       ",
"                                             D                                                                       ",
"              	       	       	       	      D	       	       	      E                                               ",
"                                             D                       D                                               ",
"                                             D                       D                                               ",
"                                             D                       D                                               ",
"                                             D                       D                                               ",
"                                             D               IHOOOOOOOOOOOOOOO                                       ",
"      E                           IHOOOOOOOOOOOOOOOOOOOOOOOOOLMPPPPPPPPPPPPPPP                                       ",
"      D                         IHLMPPPPPPPPPPPPPPPPPPPPPPPPPNNNNNNNNNNNNNNNNN                                       ",
"      D         E             IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN                                       ",
"      D         D           IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN                                       ",
"      D         D         IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN                                       ",
"      D         D       IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN                                       ",
"      D         D     IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN                                       ",
"OOOOOOOOOOOOOOOOOOOOOOLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNOOOOOOOOOOOOO                          ",
"PPPPPPPPPPPPPPPPPPPPPPNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNPPPPPPPPPPPPP                          ",
"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN                          ",
"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN                          ",
"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN                          ",
"                                                                              QQQQQQQQQQQQQ                          ",
"                                                                              QQQQQQQQQQQQQ                          ",
"                                                                              QQQQQQQQQQQQQ                          ",
"                                                                              QQQQQQQQQQQQQ             IHOOOOOOOOOOO",
"                                                                              QQQQQQQQQQQQQ           IHLMPPPPPPPPPPP",
"                                                                              QQQQQQQQQQQQQ         IHLMNNNNNNNNNNNNN",
"                                                          E                   QQQQQQQQQQQQQ       IHLMNNNNNNNNNNNNNNN",
"         E                                                D                   QQQQQQQQQQQQQ     IHLMNNNNNNNNNNNNNNNNN",
"         D                                                D                 IHOOOOOOOOOOOOOOOOOOLMNNNNNNNNNNNNNNNNNNN",
"         D                                  E             D               IHLMPPPPPPPPPPPPPPPPPPNNNNNNNNNNNNNNNNNNNNN",
"         D                     E            D             D             IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN",
"         D         E           D            D             D           IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN",
"         D         D           D            D             D         IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN",
"         D         D           D            D             D       IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN",
"         D         D           D            D             D     IHLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOLMNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN",
"PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN",
"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN",
"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN",
};


char **tile_pix[NUMTILES] = {
  type1_xpm,
  type2_xpm,
  type3_xpm,
  type4_xpm,
  type5_xpm,
  type6_xpm,
  type7_xpm,
  type8_xpm,
  type9_xpm,
  type10_xpm,
  type11_xpm,
  type12_xpm,
  type13_xpm,
  type1_xpm,
  type2_xpm,
  type3_xpm,
  type14_xpm
};

Pixmap Tile_pxm[NUMTILES],Tile_mask[NUMTILES];

extern "C" {
  void MakeTiles(XhedgehogWin *w) {
    for(int i = 0; i < NUMTILES; i++) {
      w->LoadPixmap(tile_pix[i],&(Tile_pxm[i]),&(Tile_mask[i]));
    }
  }
  int GetTileStatus(int f) {
    switch(f) {
    case 'B':
      return 0;
    case 'I':
      return 0x101;
    case 'H':
      return 1;
    case 'L':
      return 0x301;
    case 'M':
      return 0x201;
    case 'F':
      return 15;
    case 'G':
      return 0x10f;
    case 'J':
      return 0x30f;
    case 'K':
      return 0x20f;
    case 'N':
      return 0x800;
    case 'O':
      return 0x800;
    case 'P':
      return 0x800;
    default:
      return -1;
    }
  }
  void MakeSprites(XhedgehogWin *w) {
    w->tspr = new TileSprite(w,117,62,Tile_pxm,Tile_mask,tile_data);
    new Monitor(w,79 * TILE_SIZE,35 * TILE_SIZE,MSHIELD);
    new Monitor(w,82 * TILE_SIZE,35 * TILE_SIZE,MDOC);
    Spring *s = new Spring(w,64 * TILE_SIZE,29 * TILE_SIZE,0,1);
    s->PlaceSpriteBehind(w->tspr);
    new Ring(w,8 * TILE_SIZE,31 * TILE_SIZE);
    new Ring(w,10 * TILE_SIZE,31 * TILE_SIZE);
    new Ring(w,12 * TILE_SIZE,31 * TILE_SIZE);
    new Ring(w,22 * TILE_SIZE,35 * TILE_SIZE);
    new Ring(w,24 * TILE_SIZE,34 * TILE_SIZE);
    new Ring(w,26 * TILE_SIZE,33 * TILE_SIZE);
    new Ring(w,28 * TILE_SIZE,32 * TILE_SIZE);
    new BuzzBot(w,52 * TILE_SIZE, 16 * TILE_SIZE);
  }
}
